      SUBROUTINE CALC(DEST,IM,IP)
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'minim.inc'
      INCLUDE 'parequ.inc'
      DIMENSION DEST(NQUMAX)
      COMPLEX*16 Z,ZL,S11,S21,S22
      REAL*8 R(2),R11(2),R21(2)
      COMMON/PRTCTL/IPRT,IFREQ
      EQUIVALENCE (Z,R(1)),(S11,R11(1)),(S21,R21(1))
C Step through the measured data. Compute impedance and insertion loss.
C      IP=1
      SQSUM=0
      SQSUM_IL=0
      ILWEI=500
      S11WEI=100
      NQU=0
      DO 100 I=1,NEXP
      PLOSS=0
      IF(IDUT(I,4).LT.0)GOTO 2000
C This is the impedance on the female connector.      
C Start with the corrected impedance of the naked female port.
      ZL=FEMALE_S11+CALKIT_FEMALE_ERROR      
C DUT13 is defined as DUT1 male connected to DUT3 female.
C Modify ZL to become the impedance seen through the cahain of DUTs
      J=4
 1010 J=J-1
      IF(J.LE.0)GOTO 1020
      IF(IDUT(I,J).EQ.0)GOTO 1010
      CALL FILLMAT(1,IDUT(I,J),S11,S21,S22)      
      CALL LOOKTHRU(ZL,P,S11,S21,S22)
      PLOSS=PLOSS+1-R11(1)**2-R11(2)**2-R21(1)**2-R21(2)**2
      GOTO 1010
 1020 CONTINUE     
      Z=ZL-Z_MEAS(I)
      NQU=NQU+1
      T=R(1)
      DEST(NQU)=T-IM*ERR(NQU)
      SQSUM=SQSUM+DEST(NQU)**2
      NQU=NQU+1
      T=R(2)
      DEST(NQU)=T-IM*ERR(NQU)
      SQSUM=SQSUM+DEST(NQU)**2
      NQU=NQU+1
      T=R(2)
      DEST(NQU)=T-IM*ERR(NQU)
      SQSUM=SQSUM+DEST(NQU)**2
      TDB=-10*LOG10(1-P-PLOSS)
      NQU=NQU+1
      T=TDB-IL_MEAS(I)
C      WRITE(*,*)TDB,IL_MEAS(I)
      DEST(NQU)=ILWEI*T-IM*ERR(NQU)
      SQSUM=SQSUM+DEST(NQU)**2
      IF(IP.EQ.1)WRITE(*,612)(IDUT(I,J),J=1,3),ZL,Z_MEAS(I),
     &ZL-Z_MEAS(I),TDB,IL_MEAS(I),T
  612 format('DUT',3I1,2('(',F5.2,F6.2,')'),'(',F5.2,F6.2,')',
     &2F8.4,F10.6)
      GOTO 3000
C !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 2000 CONTINUE
C This is the impedance on the male connector.      
C Start with the corrected impedance of the naked male port.
      ZL=MALE_S11+CALKIT_MALE_ERROR      
      J=0
 2010 J=J+1
      IF(J.GE.4)GOTO 2020
      IF(IDUT(I,J).EQ.0)GOTO 2020
      CALL FILLMAT(-1,IDUT(I,J),S11,S21,S22)      
      CALL LOOKTHRU(ZL,P,S11,S21,S22)
      PLOSS=PLOSS+1-R11(1)**2-R11(2)**2-R21(1)**2-R21(2)**2
      GOTO 2010
 2020 CONTINUE     
      Z=ZL-Z_MEAS(I)
      NQU=NQU+1
      T=R(1)
      DEST(NQU)=T-IM*ERR(NQU)
      SQSUM=SQSUM+DEST(NQU)**2
      NQU=NQU+1
      T=R(2)
      DEST(NQU)=T-IM*ERR(NQU)
      SQSUM=SQSUM+DEST(NQU)**2
      NQU=NQU+1
      T=R(2)
      DEST(NQU)=T-IM*ERR(NQU)
      SQSUM=SQSUM+DEST(NQU)**2
      TDB=-10*LOG10(1-P-PLOSS)
      NQU=NQU+1
      T=TDB-IL_MEAS(I)
      DEST(NQU)=ILWEI*T-IM*ERR(NQU)
      SQSUM=SQSUM+DEST(NQU)**2
      IF(IP.EQ.1)WRITE(*,612)(IDUT(I,J),J=1,3),ZL,Z_MEAS(I),
     &ZL-Z_MEAS(I),TDB,IL_MEAS(I),T
 3000 CONTINUE
      IF(IP.EQ.1)SQSUM_IL=SQSUM_IL+T**2
  100 CONTINUE
C |S11| = |S22|
      NQU=NQU+1
      Z=DUT1_S11
      T1=R(1)**2+R(2)**2
      Z=DUT1_S22
      T2=R(1)**2+R(2)**2
      DEST(NQU)=S11WEI*(T1-T2)-IM*ERR(NQU)
      SQSUM=SQSUM+DEST(NQU)**2
      NQU=NQU+1
      Z=DUT3_S11
      T1=R(1)**2+R(2)**2
      Z=DUT3_S22
      T2=R(1)**2+R(2)**2
      DEST(NQU)=S11WEI*(T1-T2)-IM*ERR(NQU)
      SQSUM=SQSUM+DEST(NQU)**2
      NQU=NQU+1
      Z=DUT8_S11
      T1=R(1)**2+R(2)**2
      Z=DUT8_S22
      T2=R(1)**2+R(2)**2
      DEST(NQU)=S11WEI*(T1-T2)-IM*ERR(NQU)
      SQSUM=SQSUM+DEST(NQU)**2
C The insertion loss should be 0 for connecting 
C without a DUT.
      ZL=FEMALE_S11+CALKIT_FEMALE_ERROR
      Z=MALE_S11+CALKIT_MALE_ERROR
      T=(Z-ZL)/(Z+ZL)
      IF(IP.EQ.1)WRITE(*,619) T
 619  FORMAT('Computed insertion loss for [none] =',F8.5);      
      NQU=NQU+1
      DEST(NQU)=10*ILWEI*T-IM*ERR(NQU)
      SQSUM=SQSUM+DEST(NQU)**2
      SQSUM=DSQRT(SQSUM/NQU)

      IF(IP.NE.1)RETURN
      SQSUM_IL=DSQRT(SQSUM_IL/NEXP)
      WRITE(*,623)SQSUM_IL
  623 FORMAT('RMS error for insertion loss',F8.5)      
      Z=DUT1_S21
      T=R(1)**2+R(2)**2
      Z=DUT1_S11
      T1=T+R(1)**2+R(2)**2
      Z=DUT1_S22
      T2=T+R(1)**2+R(2)**2
      T=-10*LOG10((T1+T2)/2)
      TDB=T
      write(*,663)1,T,T1,T2
  663 FORMAT('DUT',I1,' Dissipative loss',F8.5,
     &' dB.  Efficiency: (S11)',F7.5,' (S22)',f7.5)      
      write(*,660)1,1,1,DUT1_S11
      write(*,660)1,2,1,DUT1_S21
      write(*,660)1,2,2,DUT1_S22
      Z=DUT3_S21
      T=R(1)**2+R(2)**2
      Z=DUT3_S11
      T1=T+R(1)**2+R(2)**2
      Z=DUT3_S22
      T2=T+R(1)**2+R(2)**2
      T=-10*LOG10((T1+T2)/2)
      TDB=TDB+T
      write(*,663)3,T,T1,T2
      write(*,660)3,1,1,DUT3_S11
      write(*,660)3,2,1,DUT3_S21
      write(*,660)3,2,2,DUT3_S22
      Z=DUT8_S21
      T=R(1)**2+R(2)**2
      Z=DUT8_S11
      T1=T+R(1)**2+R(2)**2
      Z=DUT8_S22
      T2=T+R(1)**2+R(2)**2
      T=-10*LOG10((T1+T2)/2)
      TDB=TDB+T
      write(*,663)8,T,T1,T2
      write(*,660)8,1,1,DUT8_S11
      write(*,660)8,2,1,DUT8_S21
      write(*,660)8,2,2,DUT8_S22
  660 FORMAT('DUT',I1,' S',2I1,': (',2F10.6,')')
      WRITE(*,664)TDB
  664 FORMAT('Sum of dissipative losses for DUT1,DUT3 and DUT8 ='
     &,F8.5,' dB')
      WRITE(*,672)CALKIT_MALE_ERROR
      WRITE(*,673)CALKIT_FEMALE_ERROR
  672 FORMAT('Calkit male LOAD error =',
     & ' (',F6.3,', i',F6.3,') Ohms')
  673 FORMAT('Calkit female LOAD error =', 
     &' (',F6.3,', i',F6.3,') Ohms')
      RETURN
      END
      SUBROUTINE FILLMAT(IDIR,NDUT,S11,S21,S22)
      INCLUDE 'prec.inc'
      INCLUDE 'header.inc'
      INCLUDE 'minim.inc'
      INCLUDE 'parequ.inc'
      COMPLEX*16 S11,S21,S22
      IF(IDIR.LT.0)GOTO 1000
      IF(NDUT.EQ.1)GOTO 101
      IF(NDUT.EQ.3)GOTO 103
      IF(NDUT.EQ.8)GOTO 108
      STOP 'ERROR FILLMAT'
  101 S11=DUT1_S11
      S21=DUT1_S21
      S22=DUT1_S22
      RETURN
  103 S11=DUT3_S11
      S21=DUT3_S21
      S22=DUT3_S22
      RETURN
  108 S11=DUT8_S11
      S21=DUT8_S21
      S22=DUT8_S22
      RETURN
 1000 CONTINUE            
      IF(NDUT.EQ.1)GOTO 1101
      IF(NDUT.EQ.3)GOTO 1103
      IF(NDUT.EQ.8)GOTO 1108
      STOP 'ERROR FILLMAT'
 1101 S11=DUT1_S22
      S21=DUT1_S21
      S22=DUT1_S11
      RETURN
 1103 S11=DUT3_S22
      S21=DUT3_S21
      S22=DUT3_S11
      RETURN
 1108 S11=DUT8_S22
      S21=DUT8_S21
      S22=DUT8_S11
      RETURN
      END
      SUBROUTINE LOOKTHRU(ZL,P,S11,S21,S22)
      INCLUDE 'prec.inc'
      COMPLEX*16 Z,GAMMA,ZL,S11,S21,S22
      REAL*8 R(2)
      EQUIVALENCE (Z,R(1))
C The input is an impedance. Convert to a reflection coefficient.
      GAMMA=(ZL-50)/(ZL+50)
C Look through the DUT
      Z=S11+(S21*S21*GAMMA)/(1-S22*GAMMA)
      P=R(1)**2+R(2)**2
C Convert back to impedance
      ZL=50*(1+Z)/(1-Z)
      RETURN
      END